//
//  Utils.hpp
//  scummvm
//
//  Created by Omer Gilad on 9/29/15.
//
//

#ifndef Utils_hpp
#define Utils_hpp

#include <vector>
#include <string>
#include "common/array.h"

#include "enhanced/ui/Strings.h"

using std::vector;
using std::string;
using std::wstring;

namespace Enhanced {
    
    class Utils {
        
    public:
        
        static vector<string> scummvmStringArrayToStdStringVector(const Common::Array<Common::String>& array);
        
        static vector<wstring> stdStringVectorToStdWstringVector(const vector<string>& array);

        static wstring stdStringToStdWstring(const string& string);

        template <typename T>
        static vector<T> arrayToStdVector(int count, const T* array) {
            vector<T> result(count);
            for (int i = 0; i < count; ++i)
            {
                result[i] = array[i];
            }
            
            return result;
        }

        static vector<wstring> stdStringIdVectorToStdWstringVector(const vector<StringId>& array);
        
        static Common::Array<int> stringToIntArray(const Common::String& value);
        static Common::String intArrayToString(const Common::Array<int>& value);
        static Common::Array<Common::String> stringToStringArray(const Common::String& value);
        static Common::String stringArrayToString(const Common::Array<Common::String>& value);
    };
}

#endif /* Utils_hpp */
